<?php

if (isset($_GET['show_source'])){
	show_source(__FILE__);   
	exit;
}

if(!isset($_POST['doit'])){
	
	##### CONFIG START #####
	
	$host1 = 'xxx.webpack.hosteurope.de';
	$port1 = 143;
	$user1 = 'wpXXXXXXXX';
	$pass1 = 'xxx';
	$sep1 = '.';
	$ssl1 = false;
	$filter1 = '/^INBOX/';
	
	$host2 = 'imap.gmail.com';
	$port2 = 993;
	$user2 = 'xxx@gmail.com';
	$pass2 = 'xxx';
	$sep2 = '/';
	$ssl2 = true;
	
	$testmode = true;
	
	##### CONFIG END #####

}else{
	
	$host1 = @$_POST['host1'];
	$port1 = @$_POST['port1'];
	$ssl1 = isset($_POST['ssl1']);
	$user1 = @$_POST['user1'];
	$pass1 = @$_POST['pass1'];
	$sep1  = @$_POST['sep1'];
	$filter1  = @$_POST['filter1'];;
	
	$host2 = @$_POST['host2'];
	$port2 = @$_POST['port2'];
	$ssl2 = isset($_POST['ssl2']);
	$user2 = @$_POST['user2'];
	$pass2 = @$_POST['pass2'];
	$sep2  = @$_POST['sep2'];
	
	$testmode = isset($_POST['testmode']);

}

function dbg($str){
	echo $str.'<br />';
}

function err($str){
	die("ERROR: $str");
}

function listFolders($mbox, $mbox_name, $pattern=false){
	$list = imap_list($mbox, $mbox_name, '*');
	if (is_array($list)) {
		$start = strlen($mbox_name);
		$folders = array(); # names encoded as iso-8859-1
		foreach ($list as $val){
			$str = imap_utf7_decode($val);
			$str = substr($str, $start);
			if (!$pattern || preg_match($pattern, $str)>0)
				$folders[] = $str;
		}
		return $folders;
	} else {
		err("imap_list failed: " . imap_last_error());
		return false;
	}
}

?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" 
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en" dir="ltr">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
<title>IMAPSyncPHP</title>
</head>
<body>
<h1>IMAPSyncPHP</h1>

<form action="<?=$_SERVER['PHP_SELF']?>" method="post">

<table>
<tr><td colspan="2"><h2>Source IMAP Account</h2></td></tr>
<tr><td>Host</td><td><input type="text" name="host1" size="48" value="<?=$host1?>" /></td></tr>
<tr><td>Port</td><td><input type="text" name="port1" size="48" value="<?=$port1?>" /></td></tr>
<tr><td>SSL? </td><td><input type="checkbox" name="ssl1"<?=$ssl1?' checked="checked"':''?> /></td></tr>
<tr><td>User</td><td><input type="text" name="user1" size="48" value="<?=$user1?>" /></td></tr>
<tr><td>Pass</td><td><input type="text" name="pass1" size="48" value="<?=$pass1?>" /></td></tr>
<tr><td>Sep </td><td><input type="text" name="sep1"  size="4"  value="<?=$sep1?>" /> </td></tr>

<tr><td>Filter</td><td><input type="text" name="filter1" size="48" value="<?=$filter1?>" />
(if not empty, only folders matching RegExp are synchronized)
</td></tr>

<tr><td colspan="2">&nbsp;</td></tr>
<tr><td colspan="2"><h2>Destination IMAP Account</h2></td></tr>
<tr><td>Host</td><td><input type="text" name="host2" size="48" value="<?=$host2?>" /></td></tr>
<tr><td>Port</td><td><input type="text" name="port2" size="48" value="<?=$port2?>" /></td></tr>
<tr><td>SSL? </td><td><input type="checkbox" name="ssl2"<?=$ssl2?' checked="checked"':''?> /></td></tr>
<tr><td>User</td><td><input type="text" name="user2" size="48" value="<?=$user2?>" /></td></tr>
<tr><td>Pass</td><td><input type="text" name="pass2" size="48" value="<?=$pass2?>" /></td></tr>
<tr><td>Sep </td><td><input type="text" name="sep2"  size="4"  value="<?=$sep2?>" /> </td></tr>
</table>

<br />
<input type="checkbox" name="testmode"<?=$testmode?' checked="checked"':''?> /> <b>Test-Mode</b> (=nothing changed on destination host)<br />
<br />
<input type="submit" name="doit" value=" OK " />
</form>

<?

if (isset($_POST['doit'])){

	echo '<hr />';
	
	$mbox1_name = '{'.$host1.':'.$port1.'/imap'.($ssl1?'/ssl':'').'}';
	$mbox1 = imap_open($mbox1_name, $user1, $pass1, OP_HALFOPEN)
		or err("can't connect: " . imap_last_error());
	
	$mbox2_name = '{'.$host2.':'.$port2.'/imap'.($ssl2?'/ssl':'').'}';
	$mbox2 = imap_open($mbox2_name, $user2, $pass2, OP_HALFOPEN)
		or err("can't connect: " . imap_last_error());
	
	dbg("Test-Mode (nothing changed on target host): ".($testmode?'yes':'no'));
	
	dbg("--------------------------------------------------------------------------------");
	dbg("STEP 1: CREATING FOLDERS IN TARGET MAILBOX");
	dbg("--------------------------------------------------------------------------------");
	
	
	$folders1 = listFolders($mbox1, $mbox1_name, $filter1);
	$folders2 = listFolders($mbox2, $mbox2_name);
	
	foreach ($folders1 as $f1){
		$f2 = implode($sep2, explode($sep1, $f1));
		if (!in_array($f2, $folders2)){
			
			dbg("creating new folder '$f2'");
			
			# CREATE
			$mbox_name_new_enc = $mbox2_name.imap_utf7_encode($f2);
			if ($testmode) 
				$ok = true;
			else
				$ok = imap_createmailbox($mbox2, $mbox_name_new_enc);
			
			if ($ok) $folders2[] = $f2;
			
		}else{
			dbg("folder '$f2' already exists");
		}
	}
		
	imap_close($mbox1);
	imap_close($mbox2);
		
	dbg("--------------------------------------------------------------------------------");
	dbg("STEP 2: COPYING MESSAGES FROM SOURCE TO TARGET MAILBOX");
	dbg("--------------------------------------------------------------------------------");
	
	foreach ($folders1 as $f1){
			
		$mbox1_name_new_enc = $mbox1_name.imap_utf7_encode($f1);		
		$mbox1 = imap_open($mbox1_name_new_enc, $user1, $pass1, OP_READONLY)
			or err("can't connect: " . imap_last_error());
		
		$cnt = imap_num_msg($mbox1);
		dbg("folder '$f1' contains $cnt messages");
		
		if ($cnt){
			
			$f2 = implode($sep2, explode($sep1, $f1));
			$mbox2_name_new_enc = $mbox2_name.imap_utf7_encode($f2);
	
			if (!$testmode) $mbox2 = imap_open($mbox2_name_new_enc, $user2, $pass2)
				or err("can't connect: " . imap_last_error());
			
			$ok = 0;
			for ($i=1;$i<=$cnt;$i++){				
				$header = @imap_fetchheader($mbox1, $i);
				$body = @imap_body($mbox1, $i);
				if ($testmode) 
					$ok++;
				else
					$ok += @imap_append($mbox2, $mbox2_name_new_enc, $header.$body);		
			}
			
			if (!$testmode) imap_close($mbox2);
			dbg("$ok messages were copied to folder '$f2'");
		}
		
		imap_close($mbox1);
	
	}

	dbg("--------------------------------------------------------------------------------");
	dbg("DONE.");
	dbg("--------------------------------------------------------------------------------");

}

?>
</body>
</html>